<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/HTML/Views/XRef.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/HTML/Views/XRef.py</title>
<link href="../../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/HTML/Views/XRef.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stephen Davies</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stefan Seefeld</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line"><span class="py-comment">#</span></span>
<a id="line8"></a><span class="lineno">  8</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> config</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> Parameter</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> ASG</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.TOC <span class="py-keyword">import</span> TOC, Linker</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.View <span class="py-keyword">import</span> View</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.Tags <span class="py-keyword">import</span> *</span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line"><span class="py-keyword">import</span> os, time</span>
<a id="line16"></a><span class="lineno"> 16</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/XRef/XRef.html">XRef</a>(View):</span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line">    <span class="py-string">&quot;&quot;&quot;A module for creating views full of xref infos&quot;&quot;&quot;</span></span>
<a id="line19"></a><span class="lineno"> 19</span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line">    link_to_scope = Parameter(True, <span class="py-string">''</span>)</span>
<a id="line21"></a><span class="lineno"> 21</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/XRef/XRef.html#register">register</a>(self, frame):</span>
<a id="line23"></a><span class="lineno"> 23</span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line">        super(XRef, self).register(frame)</span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line">        self.__filename = None</span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line">        self.__title = None</span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">        self.__toc = TOC(None)</span>
<a id="line28"></a><span class="lineno"> 28</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line">        <span class="py-keyword">if</span> self.processor.sxr_prefix <span class="py-keyword">is</span> None: <span class="py-keyword">return</span></span>
<a id="line30"></a><span class="lineno"> 30</span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">        self.icon = <span class="py-string">'xref.png'</span></span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line">        share = config.datadir</span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line">        src = os.path.join(share, <span class="py-string">'xref.png'</span>)</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line">        self.directory_layout.copy_file(src, self.icon)</span>
<a id="line35"></a><span class="lineno"> 35</span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line">        <span class="py-comment"># Add an entry for every xref</span></span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line">        <span class="py-keyword">for</span> name <span class="py-keyword">in</span> self.processor.ir.sxr.keys():</span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">            page = self.processor.xref.get(name)</span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">            file = self.directory_layout.special(<span class="py-string">'xref%d'</span>%page)</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">            file += <span class="py-string">'#'</span> + quote_as_id(str(name))</span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">            self.__toc.insert(TOC.Entry(name, file, <span class="py-string">'C++'</span>, <span class="py-string">'xref'</span>))</span>
<a id="line42"></a><span class="lineno"> 42</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/XRef/XRef.html#toc">toc</a>(self, start):</span>
<a id="line44"></a><span class="lineno"> 44</span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line">        <span class="py-keyword">return</span> self.__toc</span>
<a id="line46"></a><span class="lineno"> 46</span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/XRef/XRef.html#filename">filename</a>(self):</span>
<a id="line48"></a><span class="lineno"> 48</span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">        <span class="py-keyword">return</span> self.__filename</span>
<a id="line50"></a><span class="lineno"> 50</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/XRef/XRef.html#title">title</a>(self):</span>
<a id="line52"></a><span class="lineno"> 52</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">        <span class="py-keyword">return</span> self.__title</span>
<a id="line54"></a><span class="lineno"> 54</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/XRef/XRef.html#process">process</a>(self):</span>
<a id="line56"></a><span class="lineno"> 56</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">        <span class="py-keyword">if</span> self.processor.sxr_prefix <span class="py-keyword">is</span> None: <span class="py-keyword">return</span></span>
<a id="line58"></a><span class="lineno"> 58</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">        pages = self.processor.xref.pages()</span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> pages: <span class="py-keyword">return</span></span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">        <span class="py-keyword">for</span> p <span class="py-keyword">in</span> range(len(pages)):</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">            self.__filename = self.directory_layout.xref(p)</span>
<a id="line63"></a><span class="lineno"> 63</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">            first, last = pages[p][0], pages[p][-1]</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">            self.__title = <span class="py-string">'Cross Reference : %s - %s'</span>%(escape(str(first)), escape(str(last)))</span>
<a id="line66"></a><span class="lineno"> 66</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">            self.start_file()</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">            self.write_navigation_bar()</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">            self.write(element(<span class="py-string">'h1'</span>, self.title()))</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">            <span class="py-keyword">for</span> name <span class="py-keyword">in</span> pages[p]:</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">                self.write(<span class="py-string">'&lt;div class=&quot;xref-name&quot;&gt;'</span>)</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">                self.process_name(name)</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">                self.write(<span class="py-string">'&lt;/div&gt;'</span>)</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">            self.end_file()</span>
<a id="line75"></a><span class="lineno"> 75</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/XRef/XRef.html#register_filenames">register_filenames</a>(self):</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Registers each view&quot;&quot;&quot;</span></span>
<a id="line78"></a><span class="lineno"> 78</span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line">        <span class="py-keyword">if</span> self.processor.sxr_prefix <span class="py-keyword">is</span> None: <span class="py-keyword">return</span></span>
<a id="line80"></a><span class="lineno"> 80</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">        pages = self.processor.xref.pages()</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> pages: <span class="py-keyword">return</span></span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">        <span class="py-keyword">for</span> p <span class="py-keyword">in</span> range(len(pages)):</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">            filename = self.directory_layout.special(<span class="py-string">'xref%d'</span>%p)</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">            self.processor.register_filename(filename, self, p)</span>
<a id="line86"></a><span class="lineno"> 86</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/XRef/XRef.html#process_link">process_link</a>(self, file, line, scope):</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Outputs the info for one link&quot;&quot;&quot;</span></span>
<a id="line89"></a><span class="lineno"> 89</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">        file_link = self.directory_layout.file_source(file)</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">        file_link = rel(self.filename(), file_link) + <span class="py-string">&quot;#%d&quot;</span>%line</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">        desc = <span class="py-string">''</span></span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">        type = self.processor.ir.asg.types.get(scope)</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">        <span class="py-keyword">if</span> isinstance(type, ASG.DeclaredTypeId):</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">            desc = <span class="py-string">' '</span> + type.declaration.type</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">        entry = self.processor.toc[scope]</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">        <span class="py-keyword">if</span> entry:</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">            label = href(rel(self.filename(), entry.link), escape(str(scope)))</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">            label = escape(str(scope))</span>
<a id="line101"></a><span class="lineno">101</span><span class="line">        self.write(<span class="py-string">'&lt;li&gt;&lt;a href=&quot;%s&quot;&gt;%s:%s&lt;/a&gt;: in%s %s&lt;/li&gt;\n'</span>%(</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">            file_link, file, line, desc, label))</span>
<a id="line103"></a><span class="lineno">103</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/XRef/XRef.html#describe_declaration">describe_declaration</a>(self, decl):</span>
<a id="line105"></a><span class="lineno">105</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Returns a description of the declaration. Detects constructors and</span></span>
<a id="line106"></a><span class="lineno">106</span><span class="line"><span class="py-string">        destructors&quot;&quot;&quot;</span></span>
<a id="line107"></a><span class="lineno">107</span>
<a id="line108"></a><span class="lineno">108</span><span class="line">        name = decl.name</span>
<a id="line109"></a><span class="lineno">109</span><span class="line">        <span class="py-keyword">if</span> isinstance(decl, ASG.Function) <span class="py-keyword">and</span> len(name) &gt; 1:</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">            real = decl.real_name[-1]</span>
<a id="line111"></a><span class="lineno">111</span><span class="line">            <span class="py-keyword">if</span> name[-2] == real:</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">                <span class="py-keyword">return</span> <span class="py-string">'Constructor '</span></span>
<a id="line113"></a><span class="lineno">113</span><span class="line">            <span class="py-keyword">elif</span> real[0] == <span class="py-string">'~'</span> <span class="py-keyword">and</span> name[-2] == real[1:]:</span>
<a id="line114"></a><span class="lineno">114</span><span class="line">                <span class="py-keyword">return</span> <span class="py-string">'Destructor '</span></span>
<a id="line115"></a><span class="lineno">115</span><span class="line">        <span class="py-keyword">return</span> decl.type.capitalize() + <span class="py-string">' '</span></span>
<a id="line116"></a><span class="lineno">116</span>
<a id="line117"></a><span class="lineno">117</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/XRef/XRef.html#process_name">process_name</a>(self, name):</span>
<a id="line118"></a><span class="lineno">118</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Outputs the info for a given name&quot;&quot;&quot;</span></span>
<a id="line119"></a><span class="lineno">119</span>
<a id="line120"></a><span class="lineno">120</span><span class="line">        entry = self.processor.ir.sxr.get(name)</span>
<a id="line121"></a><span class="lineno">121</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> entry: <span class="py-keyword">return</span></span>
<a id="line122"></a><span class="lineno">122</span><span class="line">        self.write(element(<span class="py-string">'a'</span>, <span class="py-string">''</span>, id=quote_as_id(str(name))))</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">        desc = <span class="py-string">''</span></span>
<a id="line124"></a><span class="lineno">124</span><span class="line">        decl = None</span>
<a id="line125"></a><span class="lineno">125</span><span class="line">        type = self.processor.ir.asg.types.get(name)</span>
<a id="line126"></a><span class="lineno">126</span><span class="line">        <span class="py-keyword">if</span> isinstance(type, ASG.DeclaredTypeId):</span>
<a id="line127"></a><span class="lineno">127</span><span class="line">            decl = type.declaration</span>
<a id="line128"></a><span class="lineno">128</span><span class="line">            desc = self.describe_declaration(decl)</span>
<a id="line129"></a><span class="lineno">129</span><span class="line">        self.write(element(<span class="py-string">'h2'</span>, desc + escape(str(name))) + <span class="py-string">'&lt;ul&gt;\n'</span>)</span>
<a id="line130"></a><span class="lineno">130</span>
<a id="line131"></a><span class="lineno">131</span><span class="line">        <span class="py-keyword">if</span> self.link_to_scope:</span>
<a id="line132"></a><span class="lineno">132</span><span class="line">            type = self.processor.ir.asg.types.get(name, None)</span>
<a id="line133"></a><span class="lineno">133</span><span class="line">            <span class="py-keyword">if</span> isinstance(type, ASG.DeclaredTypeId):</span>
<a id="line134"></a><span class="lineno">134</span><span class="line">                link = self.directory_layout.link(type.declaration)</span>
<a id="line135"></a><span class="lineno">135</span><span class="line">                self.write(<span class="py-string">'&lt;li&gt;'</span>+href(rel(self.__filename, link), <span class="py-string">'Documentation'</span>)+<span class="py-string">'&lt;/li&gt;'</span>)</span>
<a id="line136"></a><span class="lineno">136</span><span class="line">        <span class="py-keyword">if</span> entry.definitions:</span>
<a id="line137"></a><span class="lineno">137</span><span class="line">            self.write(<span class="py-string">'&lt;li&gt;Defined at:\n&lt;ul&gt;\n'</span>)</span>
<a id="line138"></a><span class="lineno">138</span><span class="line">            <span class="py-keyword">for</span> file, line, scope <span class="py-keyword">in</span> entry.definitions:</span>
<a id="line139"></a><span class="lineno">139</span><span class="line">                self.process_link(file, line, scope)</span>
<a id="line140"></a><span class="lineno">140</span><span class="line">            self.write(<span class="py-string">'&lt;/ul&gt;&lt;/li&gt;\n'</span>)</span>
<a id="line141"></a><span class="lineno">141</span><span class="line">        <span class="py-keyword">if</span> entry.calls:</span>
<a id="line142"></a><span class="lineno">142</span><span class="line">            self.write(<span class="py-string">'&lt;li&gt;Called from:\n&lt;ul&gt;\n'</span>)</span>
<a id="line143"></a><span class="lineno">143</span><span class="line">            <span class="py-keyword">for</span> file, line, scope <span class="py-keyword">in</span> entry.calls:</span>
<a id="line144"></a><span class="lineno">144</span><span class="line">                self.process_link(file, line, scope)</span>
<a id="line145"></a><span class="lineno">145</span><span class="line">            self.write(<span class="py-string">'&lt;/ul&gt;&lt;/li&gt;\n'</span>)</span>
<a id="line146"></a><span class="lineno">146</span><span class="line">        <span class="py-keyword">if</span> entry.references:</span>
<a id="line147"></a><span class="lineno">147</span><span class="line">            self.write(<span class="py-string">'&lt;li&gt;Referenced from:\n&lt;ul&gt;\n'</span>)</span>
<a id="line148"></a><span class="lineno">148</span><span class="line">            <span class="py-keyword">for</span> file, line, scope <span class="py-keyword">in</span> entry.references:</span>
<a id="line149"></a><span class="lineno">149</span><span class="line">                self.process_link(file, line, scope)</span>
<a id="line150"></a><span class="lineno">150</span><span class="line">            self.write(<span class="py-string">'&lt;/ul&gt;&lt;/li&gt;\n'</span>)</span>
<a id="line151"></a><span class="lineno">151</span><span class="line">        <span class="py-keyword">if</span> isinstance(decl, ASG.Scope) <span class="py-keyword">and</span> decl.declarations:</span>
<a id="line152"></a><span class="lineno">152</span><span class="line">            self.write(<span class="py-string">'&lt;li&gt;Declarations:\n&lt;ul&gt;\n'</span>)</span>
<a id="line153"></a><span class="lineno">153</span><span class="line">            <span class="py-keyword">for</span> child <span class="py-keyword">in</span> decl.declarations:</span>
<a id="line154"></a><span class="lineno">154</span><span class="line">                <span class="py-keyword">if</span> isinstance(child, ASG.Builtin) <span class="py-keyword">and</span> child.type == <span class="py-string">'EOS'</span>:</span>
<a id="line155"></a><span class="lineno">155</span><span class="line">                    <span class="py-keyword">continue</span></span>
<a id="line156"></a><span class="lineno">156</span><span class="line">                file, line = child.file.name, child.line</span>
<a id="line157"></a><span class="lineno">157</span><span class="line">                file_link = self.directory_layout.file_source(file)</span>
<a id="line158"></a><span class="lineno">158</span><span class="line">                file_link = rel(self.filename(),file_link) + <span class="py-string">'#%d'</span>%line</span>
<a id="line159"></a><span class="lineno">159</span><span class="line">                file_href = <span class="py-string">'&lt;a href=&quot;%s&quot;&gt;%s:%s&lt;/a&gt;: '</span>%(file_link,file,line)</span>
<a id="line160"></a><span class="lineno">160</span><span class="line">                cname = child.name</span>
<a id="line161"></a><span class="lineno">161</span><span class="line">                entry = self.processor.toc[cname]</span>
<a id="line162"></a><span class="lineno">162</span><span class="line">                type = self.describe_declaration(child)</span>
<a id="line163"></a><span class="lineno">163</span><span class="line">                <span class="py-keyword">if</span> entry:</span>
<a id="line164"></a><span class="lineno">164</span><span class="line">                    link = href(rel(self.filename(), entry.link), escape(str(name.prune(cname))))</span>
<a id="line165"></a><span class="lineno">165</span><span class="line">                    self.write(element(<span class="py-string">'li'</span>, file_href + type + link))</span>
<a id="line166"></a><span class="lineno">166</span><span class="line">                <span class="py-keyword">else</span>:</span>
<a id="line167"></a><span class="lineno">167</span><span class="line">                    self.write(element(<span class="py-string">'li'</span>, file_href + type + str(name.prune(cname))))</span>
<a id="line168"></a><span class="lineno">168</span><span class="line">            self.write(<span class="py-string">'&lt;/ul&gt;\n&lt;/li&gt;\n'</span>)</span>
<a id="line169"></a><span class="lineno">169</span><span class="line">        self.write(<span class="py-string">'&lt;/ul&gt;\n'</span>)</span>
<a id="line170"></a><span class="lineno">170</span>
<a id="line171"></a><span class="lineno">171</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/XRef/XRef.html#end_file">end_file</a>(self):</span>
<a id="line172"></a><span class="lineno">172</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Overrides end_file to provide synopsis logo&quot;&quot;&quot;</span></span>
<a id="line173"></a><span class="lineno">173</span>
<a id="line174"></a><span class="lineno">174</span><span class="line">        self.write(<span class="py-string">'\n'</span>)</span>
<a id="line175"></a><span class="lineno">175</span><span class="line">        now = time.strftime(<span class="py-string">r'%c'</span>, time.localtime(time.time()))</span>
<a id="line176"></a><span class="lineno">176</span><span class="line">        logo = img(src=rel(self.filename(), <span class="py-string">'synopsis.png'</span>), alt=<span class="py-string">'logo'</span>)</span>
<a id="line177"></a><span class="lineno">177</span><span class="line">        logo = href(<span class="py-string">'http://synopsis.fresco.org'</span>, logo + <span class="py-string">' synopsis'</span>, target=<span class="py-string">'_blank'</span>)</span>
<a id="line178"></a><span class="lineno">178</span><span class="line">        logo += <span class="py-string">' (version %s)'</span>%config.version</span>
<a id="line179"></a><span class="lineno">179</span><span class="line">        self.write(div(<span class="py-string">'logo'</span>, <span class="py-string">'Generated on '</span> + now + <span class="py-string">' by \n&lt;br/&gt;\n'</span> + logo))</span>
<a id="line180"></a><span class="lineno">180</span><span class="line">        View.end_file(self)</span>
<a id="line181"></a><span class="lineno">181</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:14 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
